/**
 *
 * This file is part of Tulip (www.tulip-software.org)
 *
 * Authors: David Auber, Patrick Mary, Morgan Mathiaut
 * from the LaBRI Visualization Team
 * Last modification : 19/01/2010
 *
 * Tulip is free software; you can redistribute it and/or modify
 * it under the terms of the Lesser GNU General Public License
 * as published by the Free Software Foundation, either version 3
 * of the License, or (at your option) any later version.
 *
 * Tulip is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 */
#ifndef Tulip_GLSCENEVISITOR_H
#define Tulip_GLSCENEVISITOR_H

#include <tulip/tulipconf.h>

namespace tlp {

  class GlSimpleEntity;
  class GlNode;
  class GlEdge;
  class GlLayer;

  class TLP_GL_SCOPE GlSceneVisitor {

  public:

    virtual ~GlSceneVisitor() {}

    virtual void visit(GlSimpleEntity *entity) {}
    virtual void visit(GlNode *glNode) {}
    virtual void visit(GlEdge *glEdge) {}
    virtual void visit(GlLayer *layer) {}

  };
  
}

#endif // Tulip_GLSCENEVISITOR_H
